.travis.yml 30.7 KB
Newer Older
1 2
language: c

3
dist: xenial
4 5

cache:
Emil Velikov's avatar
Emil Velikov committed
6
  apt: true
7
  ccache: true
8 9 10

env:
  global:
11 12 13
    - XORG_RELEASES=https://xorg.freedesktop.org/releases/individual
    - XCB_RELEASES=https://xcb.freedesktop.org/dist
    - WAYLAND_RELEASES=https://wayland.freedesktop.org/releases
14 15 16 17
    - XORGMACROS_VERSION=util-macros-1.19.0
    - GLPROTO_VERSION=glproto-1.4.17
    - DRI2PROTO_VERSION=dri2proto-2.8
    - LIBPCIACCESS_VERSION=libpciaccess-0.13.4
18
    - LIBDRM_VERSION=libdrm-2.4.95
19
    - XCBPROTO_VERSION=xcb-proto-1.13
20 21
    - RANDRPROTO_VERSION=randrproto-1.3.0
    - LIBXRANDR_VERSION=libXrandr-1.3.0
22
    - LIBXCB_VERSION=libxcb-1.13
23
    - LIBXSHMFENCE_VERSION=libxshmfence-1.2
24
    - LIBVDPAU_VERSION=libvdpau-1.1
25
    - LIBVA_VERSION=libva-1.7.0
26
    - LIBWAYLAND_VERSION=wayland-1.15.0
27 28
    - WAYLAND_PROTOCOLS_VERSION=wayland-protocols-1.8
    - PKG_CONFIG_PATH=$HOME/prefix/lib/pkgconfig:$HOME/prefix/share/pkgconfig
29
    - LD_LIBRARY_PATH="$HOME/prefix/lib:$LD_LIBRARY_PATH"
30
    - PATH="$HOME/prefix/bin:$PATH"
31 32 33

matrix:
  include:
34 35 36
    - env:
        - LABEL="meson Vulkan"
        - BUILD=meson
37
        - UNWIND="false"
38
        - DRI_LOADERS="-Dglx=disabled -Dgbm=false -Degl=false -Dplatforms=x11,wayland,drm -Dosmesa=none"
39
        - GALLIUM_ST="-Ddri3=true -Dgallium-vdpau=false -Dgallium-xvmc=false -Dgallium-omx=disabled -Dgallium-va=false -Dgallium-xa=false -Dgallium-nine=false -Dgallium-opencl=disabled"
40
        - VULKAN_DRIVERS="intel,amd"
41
        - LLVM_VERSION=7
42
        - LLVM_CONFIG="llvm-config-${LLVM_VERSION}"
43 44 45
      addons:
        apt:
          sources:
46
            - sourceline: 'deb http://apt.llvm.org/xenial/ llvm-toolchain-xenial-7 main'
47
              key_url: https://apt.llvm.org/llvm-snapshot.gpg.key
48
          packages:
49
            - llvm-7-dev
50 51 52
            # Common
            - xz-utils
            - libexpat1-dev
53
            - libx11-xcb-dev
54
            - libelf-dev
55
            - python3.5
56
            - python3-pip
57
            - python3-setuptools
58 59 60
    - env:
        - LABEL="meson loaders/classic DRI"
        - BUILD=meson
61
        - UNWIND="false"
62
        - DRI_LOADERS="-Dglx=dri -Dgbm=true -Degl=true -Dplatforms=x11,wayland,drm,surfaceless -Dosmesa=classic"
63
        - DRI_DRIVERS="i915,i965,r100,r200,swrast,nouveau"
64
        - GALLIUM_ST="-Ddri3=true -Dgallium-vdpau=false -Dgallium-xvmc=false -Dgallium-omx=disabled -Dgallium-va=false -Dgallium-xa=false -Dgallium-nine=false -Dgallium-opencl=disabled"
65 66 67 68 69
      addons:
        apt:
          packages:
            - xz-utils
            - x11proto-xf86vidmode-dev
70
            - libxxf86vm-dev
71 72 73 74
            - libexpat1-dev
            - libx11-xcb-dev
            - libxdamage-dev
            - libxfixes-dev
75
            - python3.5
76
            - python3-pip
77
            - python3-setuptools
78
    - env:
79
        - LABEL="make loaders/classic DRI"
80
        - BUILD=make
81
        - MAKEFLAGS="-j4"
82
        - MAKE_CHECK_COMMAND="make check"
83
        - DRI_LOADERS="--enable-glx --enable-gbm --enable-egl --with-platforms=x11,drm,surfaceless,wayland --enable-osmesa"
84
        - DRI_DRIVERS="i915,i965,radeon,r200,swrast,nouveau"
85
        - GALLIUM_ST="--enable-dri --disable-opencl --disable-xa --disable-nine --disable-xvmc --disable-vdpau --disable-va --disable-omx-bellagio --disable-gallium-osmesa"
86 87
        - GALLIUM_DRIVERS=""
        - VULKAN_DRIVERS=""
88
        - LIBUNWIND_FLAGS="--disable-libunwind"
89 90 91
      addons:
        apt:
          packages:
92
            - xz-utils
93
            - x11proto-xf86vidmode-dev
94
            - libxxf86vm-dev
95 96
            - libexpat1-dev
            - libx11-xcb-dev
97 98
            - libxdamage-dev
            - libxfixes-dev
99
            - python3-pip
100
            - python3-setuptools
101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287
    - env:
        # NOTE: Building SWR is 2x (yes two) times slower than all the other
        # gallium drivers combined.
        # Start this early so that it doesn't hunder the run time.
        - LABEL="meson Gallium Drivers SWR"
        - BUILD=meson
        - UNWIND="true"
        - DRI_LOADERS="-Dglx=disabled -Degl=false -Dgbm=false"
        - GALLIUM_ST="-Ddri3=false -Dgallium-vdpau=false -Dgallium-xvmc=false -Dgallium-omx=disabled -Dgallium-va=false -Dgallium-xa=false -Dgallium-nine=false -Dgallium-opencl=disabled"
        - GALLIUM_DRIVERS="swr"
        - LLVM_VERSION=6.0
        - LLVM_CONFIG="llvm-config-${LLVM_VERSION}"
      addons:
        apt:
          packages:
            - llvm-6.0-dev
            # Common
            - xz-utils
            - libexpat1-dev
            - libx11-xcb-dev
            - libelf-dev
            - libunwind8-dev
            - python3.5
            - python3-pip
            - python3-setuptools
    - env:
        - LABEL="meson Gallium Drivers RadeonSI"
        - BUILD=meson
        - UNWIND="true"
        - DRI_LOADERS="-Dglx=disabled -Degl=false -Dgbm=false"
        - GALLIUM_ST="-Ddri3=false -Dgallium-vdpau=false -Dgallium-xvmc=false -Dgallium-omx=disabled -Dgallium-va=false -Dgallium-xa=false -Dgallium-nine=false -Dgallium-opencl=disabled"
        - GALLIUM_DRIVERS="radeonsi"
        - LLVM_VERSION=7
        - LLVM_CONFIG="llvm-config-${LLVM_VERSION}"
      addons:
        apt:
          sources:
            - sourceline: 'deb http://apt.llvm.org/xenial/ llvm-toolchain-xenial-7 main'
              key_url: https://apt.llvm.org/llvm-snapshot.gpg.key
          packages:
            # From sources above
            - llvm-7-dev
            # Common
            - xz-utils
            - libexpat1-dev
            - libx11-xcb-dev
            - libelf-dev
            - libunwind8-dev
            - python3.5
            - python3-pip
            - python3-setuptools
    - env:
        - LABEL="meson Gallium Drivers Other"
        - BUILD=meson
        - UNWIND="true"
        - DRI_LOADERS="-Dglx=disabled -Degl=false -Dgbm=false"
        - GALLIUM_ST="-Ddri3=false -Dgallium-vdpau=false -Dgallium-xvmc=false -Dgallium-omx=disabled -Dgallium-va=false -Dgallium-xa=false -Dgallium-nine=false -Dgallium-opencl=disabled"
        - GALLIUM_DRIVERS="i915,nouveau,pl111,r300,r600,freedreno,svga,swrast,v3d,vc4,virgl,etnaviv,imx"
        - LLVM_VERSION=5.0
        - LLVM_CONFIG="llvm-config-${LLVM_VERSION}"
      addons:
        apt:
          packages:
            # LLVM packaging is broken and misses these dependencies
            - libedit-dev
            - llvm-5.0-dev
            # Common
            - xz-utils
            - libexpat1-dev
            - libx11-xcb-dev
            - libelf-dev
            - libunwind8-dev
            - python3.5
            - python3-pip
            - python3-setuptools
    - env:
        - LABEL="meson Gallium ST Clover LLVM-5.0"
        - BUILD=meson
        - UNWIND="true"
        - DRI_LOADERS="-Dglx=disabled -Degl=false -Dgbm=false"
        - GALLIUM_ST="-Ddri3=false -Dgallium-vdpau=false -Dgallium-xvmc=false -Dgallium-omx=disabled -Dgallium-va=false -Dgallium-xa=false -Dgallium-nine=false -Dgallium-opencl=icd"
        - GALLIUM_DRIVERS="r600"
        - LLVM_VERSION=5.0
        - LLVM_CONFIG="llvm-config-${LLVM_VERSION}"
      addons:
        apt:
          packages:
            - libclc-dev
            # LLVM packaging is broken and misses these dependencies
            - libedit-dev
            - llvm-5.0-dev
            - clang-5.0
            - libclang-5.0-dev
            # Common
            - xz-utils
            - libexpat1-dev
            - libx11-xcb-dev
            - libelf-dev
            - libunwind8-dev
            - python3-pip
            - python3-setuptools
    - env:
        - LABEL="meson Gallium ST Clover LLVM-6.0"
        - BUILD=meson
        - UNWIND="true"
        - DRI_LOADERS="-Dglx=disabled -Degl=false -Dgbm=false"
        - GALLIUM_ST="-Ddri3=false -Dgallium-vdpau=false -Dgallium-xvmc=false -Dgallium-omx=disabled -Dgallium-va=false -Dgallium-xa=false -Dgallium-nine=false -Dgallium-opencl=icd"
        - GALLIUM_DRIVERS="r600"
        - LLVM_VERSION=6.0
        - LLVM_CONFIG="llvm-config-${LLVM_VERSION}"
      addons:
        apt:
          packages:
            - libclc-dev
            - llvm-6.0-dev
            - clang-6.0
            - libclang-6.0-dev
            # Common
            - xz-utils
            - libexpat1-dev
            - libx11-xcb-dev
            - libelf-dev
            - libunwind8-dev
            - python3.5
            - python3-pip
            - python3-setuptools
    - env:
        - LABEL="meson Gallium ST Clover LLVM-7"
        - BUILD=meson
        - UNWIND="true"
        - DRI_LOADERS="-Dglx=disabled -Degl=false -Dgbm=false"
        - GALLIUM_ST="-Ddri3=false -Dgallium-vdpau=false -Dgallium-xvmc=false -Dgallium-omx=disabled -Dgallium-va=false -Dgallium-xa=false -Dgallium-nine=false -Dgallium-opencl=icd"
        - GALLIUM_DRIVERS="r600,radeonsi"
        - LLVM_VERSION=7
        - LLVM_CONFIG="llvm-config-${LLVM_VERSION}"
      addons:
        apt:
          sources:
            - sourceline: 'deb http://apt.llvm.org/xenial/ llvm-toolchain-xenial-7 main'
              key_url: https://apt.llvm.org/llvm-snapshot.gpg.key
          packages:
            - libclc-dev
            # From sources above
            - llvm-7-dev
            - clang-7
            - libclang-7-dev
            # Common
            - xz-utils
            - libexpat1-dev
            - libx11-xcb-dev
            - libelf-dev
            - libunwind8-dev
            - python3.5
            - python3-pip
            - python3-setuptools
    - env:
        - LABEL="meson Gallium ST Other"
        - BUILD=meson
        - UNWIND="true"
        - DRI_LOADERS="-Dglx=disabled -Degl=false -Dgbm=false"
        - GALLIUM_ST="-Ddri3=true -Dgallium-vdpau=true -Dgallium-xvmc=true -Dgallium-omx=bellagio -Dgallium-va=true -Dgallium-xa=true -Dgallium-nine=true -Dgallium-opencl=disabled -Dosmesa=gallium"
        # We need swrast for osmesa and nine.
        # Nouveau supports, or builds at least against all ST.
        - GALLIUM_DRIVERS="nouveau,swrast"
        - LLVM_VERSION=5.0
        - LLVM_CONFIG="llvm-config-${LLVM_VERSION}"
      addons:
        apt:
          packages:
            - llvm-5.0-dev
            # LLVM packaging is broken and misses these dependencies
            - libedit-dev
            # Nine requires gcc 4.6... which is the one we have right ?
            - libxvmc-dev
            # Build locally, for now.
            #- libvdpau-dev
            #- libva-dev
            - libomxil-bellagio-dev
            # Common
            - xz-utils
            - libexpat1-dev
            - libx11-xcb-dev
            - libelf-dev
            - libunwind8-dev
            - python3.5
            - python3-pip
            - python3-setuptools
288 289 290 291 292 293
    - env:
        # NOTE: Building SWR is 2x (yes two) times slower than all the other
        # gallium drivers combined.
        # Start this early so that it doesn't hunder the run time.
        - LABEL="make Gallium Drivers SWR"
        - BUILD=make
294
        - MAKEFLAGS="-j4"
295
        - MAKE_CHECK_COMMAND="true"
296
        - LLVM_VERSION=6.0
297
        - LLVM_CONFIG="llvm-config-${LLVM_VERSION}"
298
        - DRI_LOADERS="--disable-glx --disable-gbm --disable-egl"
299
        - DRI_DRIVERS=""
300
        - GALLIUM_ST="--enable-dri --disable-opencl --disable-xa --disable-nine --disable-xvmc --disable-vdpau --disable-va --disable-omx-bellagio --disable-gallium-osmesa"
301 302
        - GALLIUM_DRIVERS="swr"
        - VULKAN_DRIVERS=""
303
        - LIBUNWIND_FLAGS="--enable-libunwind"
304 305 306
      addons:
        apt:
          packages:
307
            - llvm-6.0-dev
308
            # Common
309
            - xz-utils
310 311 312
            - libexpat1-dev
            - libx11-xcb-dev
            - libelf-dev
313
            - libunwind8-dev
314
            - python3-pip
315
            - python3-setuptools
316 317 318 319 320
    - env:
        - LABEL="make Gallium Drivers RadeonSI"
        - BUILD=make
        - MAKEFLAGS="-j4"
        - MAKE_CHECK_COMMAND="true"
321
        - LLVM_VERSION=7
322 323 324 325 326 327 328 329 330 331
        - LLVM_CONFIG="llvm-config-${LLVM_VERSION}"
        - DRI_LOADERS="--disable-glx --disable-gbm --disable-egl"
        - DRI_DRIVERS=""
        - GALLIUM_ST="--enable-dri --disable-opencl --disable-xa --disable-nine --disable-xvmc --disable-vdpau --disable-va --disable-omx-bellagio --disable-gallium-osmesa"
        - GALLIUM_DRIVERS="radeonsi"
        - VULKAN_DRIVERS=""
        - LIBUNWIND_FLAGS="--enable-libunwind"
      addons:
        apt:
          sources:
332
            - sourceline: 'deb http://apt.llvm.org/xenial/ llvm-toolchain-xenial-7 main'
333
              key_url: https://apt.llvm.org/llvm-snapshot.gpg.key
334 335
          packages:
            # From sources above
336
            - llvm-7-dev
337 338 339 340 341 342
            # Common
            - xz-utils
            - libexpat1-dev
            - libx11-xcb-dev
            - libelf-dev
            - libunwind8-dev
343
            - python3-pip
344
            - python3-setuptools
345 346 347
    - env:
        - LABEL="make Gallium Drivers Other"
        - BUILD=make
348
        - MAKEFLAGS="-j4"
349 350 351 352 353
        - MAKE_CHECK_COMMAND="true"
        - LLVM_VERSION=3.9
        - LLVM_CONFIG="llvm-config-${LLVM_VERSION}"
        - DRI_LOADERS="--disable-glx --disable-gbm --disable-egl"
        - DRI_DRIVERS=""
354
        - GALLIUM_ST="--enable-dri --disable-opencl --disable-xa --disable-nine --disable-xvmc --disable-vdpau --disable-va --disable-omx-bellagio --disable-gallium-osmesa"
355
        - GALLIUM_DRIVERS="i915,nouveau,pl111,r300,r600,freedreno,svga,swrast,v3d,vc4,virgl,etnaviv,imx"
356
        - VULKAN_DRIVERS=""
357
        - LIBUNWIND_FLAGS="--enable-libunwind"
358 359 360 361 362 363 364
      addons:
        apt:
          packages:
            # LLVM packaging is broken and misses these dependencies
            - libedit-dev
            - llvm-3.9-dev
            # Common
365
            - xz-utils
366 367
            - libexpat1-dev
            - libx11-xcb-dev
368
            - libelf-dev
369
            - libunwind8-dev
370
            - python3-pip
371
            - python3-setuptools
372 373 374 375 376 377 378 379 380 381
    - env:
        - LABEL="make Gallium ST Clover LLVM-3.9"
        - BUILD=make
        - MAKEFLAGS="-j4"
        - MAKE_CHECK_COMMAND="true"
        - LLVM_VERSION=3.9
        - LLVM_CONFIG="llvm-config-${LLVM_VERSION}"
        - DRI_LOADERS="--disable-glx --disable-gbm --disable-egl"
        - DRI_DRIVERS=""
        - GALLIUM_ST="--disable-dri --enable-opencl --enable-opencl-icd --enable-llvm --disable-xa --disable-nine --disable-xvmc --disable-vdpau --disable-va --disable-omx-bellagio --disable-gallium-osmesa"
382
        - GALLIUM_DRIVERS="r600"
383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399
        - VULKAN_DRIVERS=""
        - LIBUNWIND_FLAGS="--enable-libunwind"
      addons:
        apt:
          packages:
            - libclc-dev
            # LLVM packaging is broken and misses these dependencies
            - libedit-dev
            - llvm-3.9-dev
            - clang-3.9
            - libclang-3.9-dev
            # Common
            - xz-utils
            - libexpat1-dev
            - libx11-xcb-dev
            - libelf-dev
            - libunwind8-dev
400
            - python3-pip
401
            - python3-setuptools
402 403 404 405 406 407 408 409 410 411
    - env:
        - LABEL="make Gallium ST Clover LLVM-4.0"
        - BUILD=make
        - MAKEFLAGS="-j4"
        - MAKE_CHECK_COMMAND="true"
        - LLVM_VERSION=4.0
        - LLVM_CONFIG="llvm-config-${LLVM_VERSION}"
        - DRI_LOADERS="--disable-glx --disable-gbm --disable-egl"
        - DRI_DRIVERS=""
        - GALLIUM_ST="--disable-dri --enable-opencl --enable-opencl-icd --enable-llvm --disable-xa --disable-nine --disable-xvmc --disable-vdpau --disable-va --disable-omx-bellagio --disable-gallium-osmesa"
412
        - GALLIUM_DRIVERS="r600"
413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429
        - VULKAN_DRIVERS=""
        - LIBUNWIND_FLAGS="--enable-libunwind"
      addons:
        apt:
          packages:
            - libclc-dev
            # LLVM packaging is broken and misses these dependencies
            - libedit-dev
            - llvm-4.0-dev
            - clang-4.0
            - libclang-4.0-dev
            # Common
            - xz-utils
            - libexpat1-dev
            - libx11-xcb-dev
            - libelf-dev
            - libunwind8-dev
430
            - python3-pip
431
            - python3-setuptools
432 433 434 435 436 437 438 439 440 441
    - env:
        - LABEL="make Gallium ST Clover LLVM-5.0"
        - BUILD=make
        - MAKEFLAGS="-j4"
        - MAKE_CHECK_COMMAND="true"
        - LLVM_VERSION=5.0
        - LLVM_CONFIG="llvm-config-${LLVM_VERSION}"
        - DRI_LOADERS="--disable-glx --disable-gbm --disable-egl"
        - DRI_DRIVERS=""
        - GALLIUM_ST="--disable-dri --enable-opencl --enable-opencl-icd --enable-llvm --disable-xa --disable-nine --disable-xvmc --disable-vdpau --disable-va --disable-omx-bellagio --disable-gallium-osmesa"
442
        - GALLIUM_DRIVERS="r600"
443 444 445 446 447 448 449 450 451 452 453 454 455 456 457 458 459
        - VULKAN_DRIVERS=""
        - LIBUNWIND_FLAGS="--enable-libunwind"
      addons:
        apt:
          packages:
            - libclc-dev
            # LLVM packaging is broken and misses these dependencies
            - libedit-dev
            - llvm-5.0-dev
            - clang-5.0
            - libclang-5.0-dev
            # Common
            - xz-utils
            - libexpat1-dev
            - libx11-xcb-dev
            - libelf-dev
            - libunwind8-dev
460
            - python3-pip
461
            - python3-setuptools
462 463 464 465 466 467 468 469 470 471
    - env:
        - LABEL="make Gallium ST Clover LLVM-6.0"
        - BUILD=make
        - MAKEFLAGS="-j4"
        - MAKE_CHECK_COMMAND="true"
        - LLVM_VERSION=6.0
        - LLVM_CONFIG="llvm-config-${LLVM_VERSION}"
        - DRI_LOADERS="--disable-glx --disable-gbm --disable-egl"
        - DRI_DRIVERS=""
        - GALLIUM_ST="--disable-dri --enable-opencl --enable-opencl-icd --enable-llvm --disable-xa --disable-nine --disable-xvmc --disable-vdpau --disable-va --disable-omx-bellagio --disable-gallium-osmesa"
472
        - GALLIUM_DRIVERS="r600"
473 474 475 476 477 478 479 480 481 482 483 484 485 486 487
        - VULKAN_DRIVERS=""
        - LIBUNWIND_FLAGS="--enable-libunwind"
      addons:
        apt:
          packages:
            - libclc-dev
            - llvm-6.0-dev
            - clang-6.0
            - libclang-6.0-dev
            # Common
            - xz-utils
            - libexpat1-dev
            - libx11-xcb-dev
            - libelf-dev
            - libunwind8-dev
488
            - python3-pip
489
            - python3-setuptools
490 491 492 493 494 495 496 497 498 499 500 501 502 503 504 505
    - env:
        - LABEL="make Gallium ST Clover LLVM-7"
        - BUILD=make
        - MAKEFLAGS="-j4"
        - MAKE_CHECK_COMMAND="true"
        - LLVM_VERSION=7
        - LLVM_CONFIG="llvm-config-${LLVM_VERSION}"
        - DRI_LOADERS="--disable-glx --disable-gbm --disable-egl"
        - DRI_DRIVERS=""
        - GALLIUM_ST="--disable-dri --enable-opencl --enable-opencl-icd --enable-llvm --disable-xa --disable-nine --disable-xvmc --disable-vdpau --disable-va --disable-omx-bellagio --disable-gallium-osmesa"
        - GALLIUM_DRIVERS="r600,radeonsi"
        - VULKAN_DRIVERS=""
        - LIBUNWIND_FLAGS="--enable-libunwind"
      addons:
        apt:
          sources:
506
            - sourceline: 'deb http://apt.llvm.org/xenial/ llvm-toolchain-xenial-7 main'
507 508 509 510 511 512 513 514 515 516 517 518 519
              key_url: https://apt.llvm.org/llvm-snapshot.gpg.key
          packages:
            - libclc-dev
            # From sources above
            - llvm-7-dev
            - clang-7
            - libclang-7-dev
            # Common
            - xz-utils
            - libexpat1-dev
            - libx11-xcb-dev
            - libelf-dev
            - libunwind8-dev
520 521 522
    - env:
        - LABEL="make Gallium ST Other"
        - BUILD=make
523
        - MAKEFLAGS="-j4"
524
        - MAKE_CHECK_COMMAND="true"
525
        - LLVM_VERSION=3.5
526
        - LLVM_CONFIG="llvm-config-${LLVM_VERSION}"
527 528
        - DRI_LOADERS="--disable-glx --disable-gbm --disable-egl"
        - DRI_DRIVERS=""
529
        - GALLIUM_ST="--enable-dri --disable-opencl --enable-xa --enable-nine --enable-xvmc --enable-vdpau --enable-va --enable-omx-bellagio --enable-gallium-osmesa"
530 531 532 533 534
        # We need swrast for osmesa and nine.
        # i915 most likely doesn't work with most ST.
        # Regardless - we're doing a quick build test here.
        - GALLIUM_DRIVERS="i915,swrast"
        - VULKAN_DRIVERS=""
535
        - LIBUNWIND_FLAGS="--enable-libunwind"
536 537 538
      addons:
        apt:
          packages:
539 540
            # We actually want to test against llvm-3.3, yet 3.5 is available
            - llvm-3.5-dev
541 542 543 544 545 546 547 548 549
            # Nine requires gcc 4.6... which is the one we have right ?
            - libxvmc-dev
            # Build locally, for now.
            #- libvdpau-dev
            #- libva-dev
            - libomxil-bellagio-dev
            # LLVM packaging is broken and misses these dependencies
            - libedit-dev
            # Common
550
            - xz-utils
551 552 553
            - libexpat1-dev
            - libx11-xcb-dev
            - libelf-dev
554
            - libunwind8-dev
555
            - python3-pip
556
            - python3-setuptools
557 558 559
    - env:
        - LABEL="make Vulkan"
        - BUILD=make
560
        - MAKEFLAGS="-j4"
561
        - MAKE_CHECK_COMMAND="make -C src/gtest check && make -C src/intel check"
562
        - LLVM_VERSION=7
563
        - LLVM_CONFIG="llvm-config-${LLVM_VERSION}"
564
        - DRI_LOADERS="--disable-glx --disable-gbm --disable-egl --with-platforms=x11,wayland"
565
        - DRI_DRIVERS=""
566
        - GALLIUM_ST="--enable-dri --enable-dri3 --disable-opencl --disable-xa --disable-nine --disable-xvmc --disable-vdpau --disable-va --disable-omx-bellagio --disable-gallium-osmesa"
567 568
        - GALLIUM_DRIVERS=""
        - VULKAN_DRIVERS="intel,radeon"
569
        - LIBUNWIND_FLAGS="--disable-libunwind"
570 571 572
      addons:
        apt:
          sources:
573
            - sourceline: 'deb http://apt.llvm.org/xenial/ llvm-toolchain-xenial-7 main'
574
              key_url: https://apt.llvm.org/llvm-snapshot.gpg.key
575 576
          packages:
            # From sources above
577
            - llvm-7-dev
578
            # Common
579
            - xz-utils
580 581 582
            - libexpat1-dev
            - libx11-xcb-dev
            - libelf-dev
583
            - python3-pip
584
            - python3-setuptools
585 586 587 588 589 590
    - env:
        - LABEL="scons"
        - BUILD=scons
        - SCONSFLAGS="-j4"
        # Explicitly disable.
        - SCONS_TARGET="llvm=0"
591 592
        # Keep it symmetrical to the make build.
        - SCONS_CHECK_COMMAND="scons llvm=0 check"
593 594 595 596
      addons:
        apt:
          packages:
            # Common
597
            - xz-utils
598 599 600 601
            - x11proto-xf86vidmode-dev
            - libexpat1-dev
            - libx11-xcb-dev
            - libelf-dev
602 603 604 605 606
    - env:
        - LABEL="scons LLVM"
        - BUILD=scons
        - SCONSFLAGS="-j4"
        - SCONS_TARGET="llvm=1"
607 608
        # Keep it symmetrical to the make build.
        - SCONS_CHECK_COMMAND="scons llvm=1 check"
609
        - LLVM_VERSION=3.5
610 611 612 613 614 615
        - LLVM_CONFIG="llvm-config-${LLVM_VERSION}"
      addons:
        apt:
          packages:
            # LLVM packaging is broken and misses these dependencies
            - libedit-dev
616 617
            # We actually want to test against llvm-3.3, yet 3.5 is available
            - llvm-3.5-dev
618
            # Common
619
            - xz-utils
620 621 622 623
            - x11proto-xf86vidmode-dev
            - libexpat1-dev
            - libx11-xcb-dev
            - libelf-dev
624 625 626 627 628
    - env:
        - LABEL="scons SWR"
        - BUILD=scons
        - SCONSFLAGS="-j4"
        - SCONS_TARGET="swr=1"
629
        - LLVM_VERSION=6.0
630
        - LLVM_CONFIG="llvm-config-${LLVM_VERSION}"
631 632
        # Keep it symmetrical to the make build. There's no actual SWR, yet.
        - SCONS_CHECK_COMMAND="true"
633 634 635
      addons:
        apt:
          packages:
636
            - llvm-6.0-dev
637
            # Common
638
            - xz-utils
639 640 641 642
            - x11proto-xf86vidmode-dev
            - libexpat1-dev
            - libx11-xcb-dev
            - libelf-dev
643 644 645 646 647 648 649
    - env:
        - LABEL="macOS make"
        - BUILD=make
        - MAKEFLAGS="-j4"
        - MAKE_CHECK_COMMAND="make check"
        - DRI_LOADERS="--with-platforms=x11 --disable-egl"
      os: osx
650 651 652
    - env:
        - LABEL="macOS meson"
        - BUILD=meson
653
        - UNWIND="false"
654
        - DRI_LOADERS="-Dglx=dri -Dgbm=false -Degl=false -Dplatforms=x11 -Dosmesa=none"
655
        - GALLIUM_ST="-Ddri3=true -Dgallium-vdpau=false -Dgallium-xvmc=false -Dgallium-omx=disabled -Dgallium-va=false -Dgallium-xa=false -Dgallium-nine=false -Dgallium-opencl=disabled"
656
      os: osx
657 658 659 660 661 662 663 664 665 666 667 668 669 670 671 672 673 674 675 676 677 678 679

before_install:
  - |
    if [[ "$TRAVIS_OS_NAME" == "osx" ]]; then
      HOMEBREW_NO_AUTO_UPDATE=1 brew install python3 ninja expat gettext
      # Set PATH for homebrew pip3 installs
      PATH="$HOME/Library/Python/3.6/bin:${PATH}"
      # Set PKG_CONFIG_PATH for keg-only expat
      PKG_CONFIG_PATH="/usr/local/opt/expat/lib/pkgconfig:${PKG_CONFIG_PATH}"
      # Set PATH for keg-only gettext
      PATH="/usr/local/opt/gettext/bin:${PATH}"

      # Install xquartz for prereqs ...
      XQUARTZ_VERSION="2.7.11"
      wget -nv https://dl.bintray.com/xquartz/downloads/XQuartz-${XQUARTZ_VERSION}.dmg
      hdiutil attach XQuartz-${XQUARTZ_VERSION}.dmg
      sudo installer -pkg /Volumes/XQuartz-${XQUARTZ_VERSION}/XQuartz.pkg -target /
      hdiutil detach /Volumes/XQuartz-${XQUARTZ_VERSION}
      # ... and set paths
      PATH="/opt/X11/bin:${PATH}"
      PKG_CONFIG_PATH="/opt/X11/share/pkgconfig:/opt/X11/lib/pkgconfig:${PKG_CONFIG_PATH}"
      ACLOCAL="aclocal -I /opt/X11/share/aclocal -I /usr/local/share/aclocal"
    fi
680 681

install:
682
  # Install a more modern meson from pip, since the version in the
683
  # ubuntu repos is often quite old.
684
  - if test "x$BUILD" = xmeson; then
685
      pip3 install --user meson;
686 687 688 689 690
      pip3 install --user mako;
    fi

  # Install autotools build dependencies
  - if test "x$BUILD" = xmake; then
691
      pip2 install --user mako;
692 693
    fi

694 695 696
  # Install a more modern scons from pip.
  - if test "x$BUILD" = xscons; then
      pip2 install --user "scons>=2.4";
697
      pip2 install --user mako;
698 699
    fi

700 701 702
  # Install dependencies where we require specific versions (or where
  # disallowed by Travis CI's package whitelisting).

703 704 705 706 707
  - |
    if [[ "$TRAVIS_OS_NAME" == "linux" ]]; then
      wget $XORG_RELEASES/util/$XORGMACROS_VERSION.tar.bz2
      tar -jxvf $XORGMACROS_VERSION.tar.bz2
      (cd $XORGMACROS_VERSION && ./configure --prefix=$HOME/prefix && make install)
708

709 710 711
      wget $XORG_RELEASES/proto/$GLPROTO_VERSION.tar.bz2
      tar -jxvf $GLPROTO_VERSION.tar.bz2
      (cd $GLPROTO_VERSION && ./configure --prefix=$HOME/prefix && make install)
712

713 714 715
      wget $XORG_RELEASES/proto/$DRI2PROTO_VERSION.tar.bz2
      tar -jxvf $DRI2PROTO_VERSION.tar.bz2
      (cd $DRI2PROTO_VERSION && ./configure --prefix=$HOME/prefix && make install)
716

717 718 719
      wget $XCB_RELEASES/$XCBPROTO_VERSION.tar.bz2
      tar -jxvf $XCBPROTO_VERSION.tar.bz2
      (cd $XCBPROTO_VERSION && ./configure --prefix=$HOME/prefix && make install)
720

721 722 723
      wget $XCB_RELEASES/$LIBXCB_VERSION.tar.bz2
      tar -jxvf $LIBXCB_VERSION.tar.bz2
      (cd $LIBXCB_VERSION && ./configure --prefix=$HOME/prefix && make install)
724

725 726 727
      wget $XORG_RELEASES/lib/$LIBPCIACCESS_VERSION.tar.bz2
      tar -jxvf $LIBPCIACCESS_VERSION.tar.bz2
      (cd $LIBPCIACCESS_VERSION && ./configure --prefix=$HOME/prefix && make install)
728

729
      wget https://dri.freedesktop.org/libdrm/$LIBDRM_VERSION.tar.bz2
730 731
      tar -jxvf $LIBDRM_VERSION.tar.bz2
      (cd $LIBDRM_VERSION && ./configure --prefix=$HOME/prefix --enable-vc4 --enable-freedreno --enable-etnaviv-experimental-api && make install)
732

733 734 735 736 737 738 739 740
      wget $XORG_RELEASES/proto/$RANDRPROTO_VERSION.tar.bz2
      tar -jxvf $RANDRPROTO_VERSION.tar.bz2
      (cd $RANDRPROTO_VERSION && ./configure --prefix=$HOME/prefix && make install)

      wget $XORG_RELEASES/lib/$LIBXRANDR_VERSION.tar.bz2
      tar -jxvf $LIBXRANDR_VERSION.tar.bz2
      (cd $LIBXRANDR_VERSION && ./configure --prefix=$HOME/prefix && make install)

741 742 743
      wget $XORG_RELEASES/lib/$LIBXSHMFENCE_VERSION.tar.bz2
      tar -jxvf $LIBXSHMFENCE_VERSION.tar.bz2
      (cd $LIBXSHMFENCE_VERSION && ./configure --prefix=$HOME/prefix && make install)
744

745
      wget https://people.freedesktop.org/~aplattner/vdpau/$LIBVDPAU_VERSION.tar.bz2
746 747
      tar -jxvf $LIBVDPAU_VERSION.tar.bz2
      (cd $LIBVDPAU_VERSION && ./configure --prefix=$HOME/prefix && make install)
748

749
      wget https://www.freedesktop.org/software/vaapi/releases/libva/$LIBVA_VERSION.tar.bz2
750 751
      tar -jxvf $LIBVA_VERSION.tar.bz2
      (cd $LIBVA_VERSION && ./configure --prefix=$HOME/prefix --disable-wayland --disable-dummy-driver && make install)
752

753 754 755
      wget $WAYLAND_RELEASES/$LIBWAYLAND_VERSION.tar.xz
      tar -axvf $LIBWAYLAND_VERSION.tar.xz
      (cd $LIBWAYLAND_VERSION && ./configure --prefix=$HOME/prefix --enable-libraries --without-host-scanner --disable-documentation --disable-dtd-validation && make install)
756

757 758 759
      wget $WAYLAND_RELEASES/$WAYLAND_PROTOCOLS_VERSION.tar.xz
      tar -axvf $WAYLAND_PROTOCOLS_VERSION.tar.xz
      (cd $WAYLAND_PROTOCOLS_VERSION && ./configure --prefix=$HOME/prefix && make install)
760

761
      # Meson requires ninja >= 1.6, but xenial has 1.3.x
762 763 764
      wget https://github.com/ninja-build/ninja/releases/download/v1.6.0/ninja-linux.zip
      unzip ninja-linux.zip
      mv ninja $HOME/prefix/bin/
765

766 767 768
      # Generate this header since one is missing on the Travis instance
      mkdir -p linux
      printf "%s\n" \
769 770 771 772 773 774 775
           "#ifndef _LINUX_MEMFD_H" \
           "#define _LINUX_MEMFD_H" \
           "" \
           "#define MFD_CLOEXEC             0x0001U" \
           "#define MFD_ALLOW_SEALING       0x0002U" \
           "" \
           "#endif /* _LINUX_MEMFD_H */" > linux/memfd.h
776 777 778 779 780 781 782 783 784 785 786 787 788 789 790 791 792 793 794 795 796 797 798 799

      # Generate this header, including the missing SYS_memfd_create
      # macro, which is not provided by the header in the Travis
      # instance
      mkdir -p sys
      printf "%s\n" \
           "#ifndef _SYSCALL_H" \
           "#define _SYSCALL_H      1" \
           "" \
           "#include <asm/unistd.h>" \
           "" \
           "#ifndef _LIBC" \
           "# include <bits/syscall.h>" \
           "#endif" \
           "" \
           "#ifndef __NR_memfd_create" \
           "# define __NR_memfd_create 319 /* Taken from <asm/unistd_64.h> */" \
           "#endif" \
           "" \
           "#ifndef SYS_memfd_create" \
           "# define SYS_memfd_create __NR_memfd_create" \
           "#endif" \
           "" \
           "#endif" > sys/syscall.h
800
    fi
801

802
script:
803
  - if test "x$BUILD" = xmake; then
804
      export CFLAGS="$CFLAGS -isystem`pwd`";
805

806 807 808
      mkdir build &&
      cd build &&
      ../autogen.sh --enable-debug
809
        $LIBUNWIND_FLAGS
810
        $DRI_LOADERS
811
        --with-dri-drivers=$DRI_DRIVERS
812
        $GALLIUM_ST
813 814
        --with-gallium-drivers=$GALLIUM_DRIVERS
        --with-vulkan-drivers=$VULKAN_DRIVERS
815
        --disable-llvm-shared-libs
816 817
        &&
      make && eval $MAKE_CHECK_COMMAND;
818 819 820
    fi

  - if test "x$BUILD" = xscons; then
821
      scons $SCONS_TARGET && eval $SCONS_CHECK_COMMAND;
822
    fi
823

824 825
  - |
    if test "x$BUILD" = xmeson; then
826 827
      # We need to control the version of llvm-config we're using, so we'll
      # generate a native file to do so. This requires meson >=0.49
828
      #
829
      echo -e "[binaries]\nllvm-config = '`which $LLVM_CONFIG`'" > native.file
830

831 832
      $LLVM_CONFIG --version

833
      export CFLAGS="$CFLAGS -isystem`pwd`"
834
      meson _build \
835
                   --native-file=native.file \
836
                   -Dbuild-tests=true \
837
                   -Dlibunwind=${UNWIND} \
838
                   ${DRI_LOADERS} \
839
                   -Ddri-drivers=${DRI_DRIVERS:-[]} \
840
                   ${GALLIUM_ST} \
841 842
                   -Dgallium-drivers=${GALLIUM_DRIVERS:-[]} \
                   -Dvulkan-drivers=${VULKAN_DRIVERS:-[]}
843
      meson configure _build
844
      ninja -C _build
845
      ninja -C _build test
846
    fi